#ifndef __FIRE_PREFIX_H__
#error "Please do not include this file directly, use prefix.h"
#endif

#ifndef __linux__
#error "ERROR: This include file is for Linux only"
#endif

/*
 * Lets do some error checking first
 */
#if !defined(__GNUC__) || !defined(__GXX_ABI_VERSION)
#error "ERROR: Unknown compiler, fdsrt only supports Gnu's C++ compiler on Linux"
#endif

#if !defined(__x86_64__) || !defined(__x86_64)
#error "ERROR: This should be defined, but isn't"
#endif

#if (__GNUC__ == 3) && (__GXX_ABI_VERSION == 102)
#define FIRE_RT_PLATFORM_CHECK "gcc3_x86_linux64"
#elif (__GNUC__ == 3) && (__GXX_ABI_VERSION == 1002)
#define FIRE_RT_PLATFORM_CHECK "gcc3a_x86_linux64"
#elif (__GNUC__ == 4) && (__GXX_ABI_VERSION == 1002)
#define FIRE_RT_PLATFORM_CHECK "gcc4_x86_linux64"
#elif (__GNUC__ == 7) && (__GXX_ABI_VERSION == 1002)
#define FIRE_RT_PLATFORM_CHECK "gcc7_x86_linux64"
#elif (__GNUC__ == 7) && (__GXX_ABI_VERSION == 1011)
#define FIRE_RT_PLATFORM_CHECK "gcc7a_x86_linux64"
#elif (__GNUC__ == 9) && (__GXX_ABI_VERSION == 1002)
#define FIRE_RT_PLATFORM_CHECK "gcc9_x86_linux64"
#elif (__GNUC__ == 9) && (__GXX_ABI_VERSION == 1013)
#define FIRE_RT_PLATFORM_CHECK "gcc9a_x86_linux64"
#else
#error "ERROR: g++ compiler version, fdsrt requires g++ Version 3,4,7 or 9 on Linux"
#endif
