#include <iostream>
#include "FDS/rt_api.h"
#include "FDS/rt_fields.h"
#include "FDS/Level2Feature.h"

using namespace std;
using namespace FDS;

static void on_message(int tag, const RT_Message *msg, const RT_Record *rec, void *closure)
{
   cout << "Symbol: " << msg->get_key() << endl;

   if (msg->get(FIDS::MSG_TYPE).to_string() == "D")
   {
      cout << "delete message" << endl;
   }
   else
   {
      if (msg->exists(FIDS::BID_INDEX_1))
      {
         cout << "Bid message: " << endl;
         cout << "Bid Price: " << msg->get(FIDS::BID_1).to_string().c_str() << endl;
         cout << "Bid Volume: "<< msg->get(FIDS::BID_VOL_1).to_string().c_str() << endl;
         cout << "Bid Time: " <<  msg->get(FIDS::BID_TIME_1).to_string().c_str() << endl;
         cout << "Bid Index: " << msg->get(FIDS::BID_INDEX_1).to_string().c_str() << endl;
         cout << "Order Code: " << msg->get(FIDS::ORDER_CODE).to_string().c_str() << endl;
         cout << "Market Maker ID: " << msg->get(FIDS::MARKET_MAKER_ID).to_string().c_str() << endl;
      }
      else
      {
         cout << "Ask message" << endl;
         cout << "Ask Price: " << msg->get(FIDS::ASK_1).to_string().c_str() << endl;
         cout << "Ask Volume: " << msg->get(FIDS::ASK_VOL_1).to_string().c_str() << endl;
         cout << "Ask Time: " << msg->get(FIDS::ASK_TIME_1).to_string().c_str() << endl;
         cout << "Ask Index: " << msg->get(FIDS::ASK_INDEX_1).to_string().c_str() << endl;
         cout << "Order Code: " << msg->get(FIDS::ORDER_CODE).to_string().c_str() << endl;
         cout << "Market Maker ID: " << msg->get(FIDS::MARKET_MAKER_ID).to_string().c_str() << endl;
      }
   }
   cout << endl;
}

int main(int argc, char *argv[])
{
   if(argc < 2)
   {
      cerr << "Usage: " << argv[0] << " <user-serial>:<password>@<hostname>" << endl;
      return 1;
   }
   FDF::set_connection_info(argv[1]);
   FDF::connect();

   Level2Feature l2 = Level2Feature();
   if (!FDF::is_active(l2))
   {
      bool res = FDF::enable(l2);
      if (!res)
      {
         cout << "Error enabling Level 2 feature" << endl;
         return -1;
      }
   }

   RT_Request req("FDS1", "AAPL:L2");
   int tag = 0;
   FDF::request(req, on_message, NULL, &tag);

   while (true)
   {
      FDF::dispatch(-1);
   }

  return 0;
}
